#! /usr/bin/env python

from io import BytesIO, StringIO

import sys
if sys.version_info <= (3,0):
    # workaround for:
    #   TypeError: initial_value must be unicode or None, not str
    from StringIO import StringIO

import yoda

aos_ref = yoda.read("test.yoda")

assert len(aos_ref.keys()) > 0
print(aos_ref.keys())

for aos in [
        yoda.read(open("test.yoda", "r")),
        yoda.read(StringIO(open("test.yoda", "r").read())),
        yoda.readYODA("test.yoda"),
        yoda.readYODA(open("test.yoda", "r")),
        yoda.readYODA(StringIO(open("test.yoda", "r").read())),

        # Compressed
        yoda.read("test.yoda.gz"),
        yoda.read(open("test.yoda.gz", "rb")),
        yoda.read(BytesIO(open("test.yoda.gz", "rb").read())),
        yoda.readYODA("test.yoda.gz"),
        yoda.readYODA(open("test.yoda.gz", "rb")),
        yoda.readYODA(BytesIO(open("test.yoda.gz", "rb").read())),
]:
    print(aos.keys())
    assert set(aos.keys()) == set(aos_ref.keys())
